#!/usr/bin/env python
# vim: set fileencoding=UTF-8 :
#Python Timerklasse importieren
import time
#Python Raspberry Pi GPIO Klasse importieren
import RPi.GPIO as GPIO
from l_config import config

class mpc3008:
    
    def __init__(self,channel):
        # Festlegung der Nutzung der vorgegebenen Nummerierung der GPIOs
        GPIO.setmode(GPIO.BOARD)    
        
        # Pin-Programmierung        
        #self.channel=config.mpc3008.channel
        self.channel=channel
        self.p_ch_select=config.mpc3008.p_ch_select
        self.p_clock=config.mpc3008.p_clock
        self.p_d_in=config.mpc3008.p_d_in
        self.p_d_out=config.mpc3008.p_d_out
        
        GPIO.setup(self.p_clock, GPIO.OUT)
        GPIO.setup(self.p_d_in, GPIO.OUT)
        GPIO.setup(self.p_d_out, GPIO.IN)
        GPIO.setup(self.p_ch_select,   GPIO.OUT)
        
    # SCI Funktion
    def read_data(self):
        # Pegel definieren
        GPIO.output(self.p_ch_select,   GPIO.HIGH)    
        GPIO.output(self.p_clock,   GPIO.LOW)
        GPIO.output(self.p_ch_select, GPIO.LOW)
            
        cmd = self.channel
        cmd |= 0b00011000 # Kommando zum Abruf der Analogwerte des Datenkanals adCh
    
        # Bitfolge senden
        for i in range(5):
            if (cmd & 0x10): # 4. Bit pr�fen und mit 0 anfangen
                GPIO.output(self.p_d_in, GPIO.HIGH)
            else:
                GPIO.output(self.p_d_in, GPIO.LOW)
            # Clocksignal negative Flanke erzeugen   
            GPIO.output(self.p_clock, GPIO.HIGH)
            GPIO.output(self.p_clock, GPIO.LOW)
            cmd <<= 1 # Bitfolge eine Position nach links verschieben
                
        # Datenabruf
        adchvalue = 0 # Wert auf 0 zur�cksetzen
        for i in range(11):
            GPIO.output(self.p_clock, GPIO.HIGH)
            GPIO.output(self.p_clock, GPIO.LOW)
            adchvalue <<= 1 # 1 Postition nach links schieben
            if(GPIO.input(self.p_d_out)):
                adchvalue |= 0x01

        return adchvalue