#!/usr/bin/env python
# vim: set fileencoding=UTF-8 :

#Libraries
import RPi.GPIO as GPIO

class config:
    #Board layout
    GPIO.setmode(GPIO.BOARD)
    
    class hardware:
        wheel_distance=0.22
        c_radarc=197.#/1000.
        mass=1.21
        r_robot=0.17
        
    class drive:        
        #Right motor pins
        p_right_bw=11
        p_right_fw=12
        p_right_pwm=16
        
        #Left motor pins
        p_left_bw=13
        p_left_fw=15
        p_left_pwm=18
        
        #Operating frequency for pwm
        freq=100
        
        #Balancing
        balance_duty_max=100
        balance_duty_min=30
    class hmc5883l:
        port=1
        address=0x1E
        #gauss = 4.7
        gauss=4.7
        declination = (2,14)
#     class mpc3008:
#         # Konfiguration Eingangskanal und GPIOs
#         channel = 0  # Analog/Digital-Channel
#         p_clock     = 36 # Clock
#         p_d_in     = 35 # Digital in
#         p_d_out    = 37  # Digital out
#         p_ch_select      = 33  # Chip-Select
    class mpc3008:
        # Konfiguration Eingangskanal und GPIOs
        #channel = 0  # Analog/Digital-Channel
        p_clock     = 23 # Clock
        p_d_in     = 19 # Digital in
        p_d_out    = 21  # Digital out
        p_ch_select      = 24  # Chip-Select
        
    class odo:
        left_channel=7
        right_channel=6
        switch_border=0.5

    class gyro:
        multiplicator=131
        zero_balance=-25
        fine_gain=1
    class us:
        pins=[
              [29,22],
              [31,32],
              [33,36],
              [35,38], 
              [37,40]
              ]



