#!/usr/bin/env python
# vim: set fileencoding=UTF-8 :
import math
import time
import numpy as np
from l_config import config
import l_compass
import l_misc
import l_drive
import l_accel
from datetime import datetime
import os
import matplotlib as mpl
#mpl.use('Agg')
import matplotlib.pyplot as plt


class control(object):
    
    def __init__(self):
        pass
    
    #Finds a direction
    def find_direction(self,target):
        drive=l_drive.drive()
        compass=l_compass.hmc5883l()

        lf=l_misc.sigmoid_function(0,180,25,80,0.05,0.1)
        epsilon=1
        while True:
            angle=compass.degrees(compass.heading())[0]
            print angle
            diff=math.fmod((target-angle)-180, 360)+180
            if abs(diff)<epsilon:
                drive.break_move()
                break
            else:
                duty=lf.get_sigmoid_value(abs(diff))
                if diff>0:
                    drive.turn_right(duty)
                else:
                    drive.turn_left(duty)
    
    #Moves along a target angle  
    def drive_heading(self,duty,target):
        drive=l_drive.drive()        
        compass=l_compass.hmc5883l()
        lf=l_misc.sigmoid_function(0,10,0,40,0.4,0.1)
        
        self.find_direction(target)
        
        while True:
            
            angle=compass.degrees(compass.heading())[0]
            diff=math.fmod((target-angle)-180, 360)+180
            balance=np.sign(diff)*lf.get_sigmoid_value(abs(diff))
            print "angle: %.2f diff: %.2f balance %.2f" %(angle,diff,balance)
            
            drive.move_fw(duty,balance)
        
    def move_to_target_distance(self,distance):
        pre_settle=1
        break_time=pre_settle+0
        after_break_time=break_time+0
        drive=l_drive.drive()
        # Sensor initialization
        mpu = l_accel.MPU6050()
        mpu.dmpInitialize()
        t0=datetime.now()
        x0=0
        v0=0
        a0=0
        t=[]
        x=[x0]
        v=[v0]
        a=[]
        while True:
            
            now=datetime.now()
            
            delta=now-t0
            tx=delta.seconds + delta.microseconds/1E6
            #print tx
            datahash=mpu.get_hash()

            if datahash:                 
                ax=datahash['g']['x']*9.807
                print datahash['g']['x']
                t.append(tx)
                a.append(ax)
            if tx>break_time and tx<after_break_time:
                drive.break_move()
            elif tx>after_break_time:
                break
            elif tx>pre_settle:
                #drive.move_fw(100,0)
                pass
        write_gnu_file("acc.dat", t, a)
        os.system("gnuplot -e \"plot  'acc.dat' using 1:2;pause -1\"")
        

