#!/usr/bin/env python
# vim: set fileencoding=UTF-8 :
import RPi.GPIO as GPIO
import sys
# import smbus
# import math
# import time
import pigpio
from l_config import config


class drive:


    
    def __init__(self):
        GPIO.setwarnings(False)
        #Class variables
        #Config
        self.p_right_fw=config.drive.p_right_fw
        self.p_right_bw=config.drive.p_right_bw
        self.p_right_pwm=config.drive.p_right_pwm
        self.p_left_fw=config.drive.p_left_fw
        self.p_left_bw=config.drive.p_left_bw
        self.p_left_pwm=config.drive.p_left_pwm
        
        #Define the pins
        #Right motor
        GPIO.setup(self.p_right_fw, GPIO.OUT)
        GPIO.setup(self.p_right_bw, GPIO.OUT)
        GPIO.setup(self.p_right_pwm, GPIO.OUT)
        #Left motor
        GPIO.setup(self.p_left_fw, GPIO.OUT)
        GPIO.setup(self.p_left_bw, GPIO.OUT)
        GPIO.setup(self.p_left_pwm, GPIO.OUT)
        
        #PWM objects
        self.m_left = GPIO.PWM(self.p_left_pwm, config.drive.freq)
        self.m_right = GPIO.PWM(self.p_right_pwm, config.drive.freq)
        
        #Movement status
        #The moving direction of the wheels
        self.sgn_left=0
        self.sgn_right=0
        #Status
        self.status=False
        self.duty=0
        self.balance=0
    #Motor functions
    def move_fw(self,duty,balance=0):
        if self.status!="move_fw":
            self.reset_gpio()
            GPIO.output(self.p_left_fw, GPIO.HIGH)
            GPIO.output(self.p_right_fw, GPIO.HIGH)            
            #Set signs
            self.sgn_left=1
            self.sgn_right=1
            #Make move
            if (duty+balance<=config.drive.balance_duty_max) and (duty+balance>=config.drive.balance_duty_min):
                self.m_left.start(duty+balance)
            elif duty+balance<config.drive.balance_duty_min:
                self.m_left.start(config.drive.balance_duty_min)
            elif duty+balance>config.drive.balance_duty_max:
                self.m_left.start(config.drive.balance_duty_max)
            else:
                print "Error"
                sys.exit()
                
            if (duty-balance<=config.drive.balance_duty_max) and (duty-balance>=config.drive.balance_duty_min):
                self.m_right.start(duty-balance)
            elif duty-balance<config.drive.balance_duty_min:
                self.m_right.start(config.drive.balance_duty_min)
            elif duty-balance>config.drive.balance_duty_max:
                self.m_right.start(config.drive.balance_duty_max)
            else:
                print "Error"
                sys.exit()
            self.status="move_fw"
            self.duty=duty
            self.balance=balance
        else:
            #pass
            if duty!=self.duty or balance!=self.balance:
                if (duty+balance<=config.drive.balance_duty_max) and (duty+balance>=config.drive.balance_duty_min):
                    self.m_left.start(duty+balance)
                elif duty+balance<config.drive.balance_duty_min:
                    self.m_left.start(config.drive.balance_duty_min)
                elif duty+balance>config.drive.balance_duty_max:
                    self.m_left.start(config.drive.balance_duty_max)
                else:
                    print "Error"
                    sys.exit()
                    
                if (duty-balance<=config.drive.balance_duty_max) and (duty-balance>=config.drive.balance_duty_min):
                    self.m_right.start(duty-balance)
                elif duty-balance<config.drive.balance_duty_min:
                    self.m_right.start(config.drive.balance_duty_min)
                elif duty-balance>config.drive.balance_duty_max:
                    self.m_right.start(config.drive.balance_duty_max)
                else:
                    print "Error"
                    sys.exit()
                    
                self.duty=duty
                self.balance=balance
            
            
        return [self.sgn_left,self.sgn_right]    
            
    def move_bw(self,duty,balance=0):
        if self.status!="move_bw":
            self.reset_gpio()
            GPIO.output(self.p_left_bw, GPIO.HIGH)
            GPIO.output(self.p_right_bw, GPIO.HIGH)
            #Set signs
            self.sgn_left=-1
            self.sgn_right=-1
            
            if duty+balance<=config.drive.balance_duty_max:
                self.m_left.start(duty+balance)
            else:
                self.m_left.start(100)
            if duty-balance>=0:
                self.m_right.start(duty-balance)
            else:
                self.m_right.start(0)
            self.status="move_bw"
            self.duty=duty
            self.balance=balance
        else:
            pass
            if duty!=self.duty or balance!=self.balance:
                if duty+balance<=config.drive.balance_duty_max:
                    self.m_left.start(duty+balance)
                else:
                    self.m_left.start(100)
                if duty-balance>=0:
                    self.m_right.start(duty-balance)
                else:
                    self.m_right.start(0)
                self.duty=duty
                self.balance=balance
                
                
                
        return [self.sgn_left,self.sgn_right]
    
    
    
    def turn_right(self,duty):
        if self.status!="turn_right":
            #print "Start new"
            self.reset_gpio()
            GPIO.output(self.p_left_fw, GPIO.HIGH)
            GPIO.output(self.p_right_bw, GPIO.HIGH)
            self.m_left.start(duty)
            self.m_right.start(duty)
            self.status="turn_right"
            self.duty_left=duty
            self.duty_right=duty
            #Set signs
            self.sgn_left=1
            self.sgn_right=-1
        else:

            if duty!=self.duty_left or duty!=self.duty_right:
                #print "Setting duty"
                self.m_left.start(duty)
                self.m_right.start(duty)
        return [self.sgn_left,self.sgn_right]
    
    
    def turn_left(self,duty):
        if self.status!="turn_left":
            self.reset_gpio()
            GPIO.output(self.p_left_bw, GPIO.HIGH)
            GPIO.output(self.p_right_fw, GPIO.HIGH)
            self.m_left.start(duty)
            self.m_right.start(duty)
            self.status="turn_left"
            self.duty_left=duty
            self.duty_right=duty
            #Set signs
            self.sgn_left=-1
            self.sgn_right=1
        else:
            if duty!=self.duty_left or duty!=self.duty_right:
                self.m_left.start(duty)
                self.m_right.start(duty)

        return [self.sgn_left,self.sgn_right]
        
        
    
    def reset_gpio(self):
        GPIO.output(self.p_left_fw, GPIO.LOW)
        GPIO.output(self.p_right_fw, GPIO.LOW)
        GPIO.output(self.p_right_bw, GPIO.LOW)
        GPIO.output(self.p_left_bw, GPIO.LOW)
        #Set signs
        self.sgn_left=0
        self.sgn_right=0
        return [self.sgn_left,self.sgn_right]
    
    def break_move(self):
        self.m_left.stop()
        self.m_right.stop()
        self.reset_gpio()
        self.status=False
        #Set signs
        self.sgn_left=0
        self.sgn_right=0
        return [self.sgn_left,self.sgn_right]
    
    
    
    
class drive_pp:


    
    def __init__(self):
        self.pi=pigpio.pi() 
        #Class variables
        #Config
        self.p_right_fw=config.drive.p_right_fw
        self.p_right_bw=config.drive.p_right_bw
        self.p_right_pwm=config.drive.p_right_pwm
        self.p_left_fw=config.drive.p_left_fw
        self.p_left_bw=config.drive.p_left_bw
        self.p_left_pwm=config.drive.p_left_pwm
        
#         #Define the pins
#         #Right motor
#         GPIO.setup(self.p_right_fw, GPIO.OUT)
#         GPIO.setup(self.p_right_bw, GPIO.OUT)
#         GPIO.setup(self.p_right_pwm, GPIO.OUT)
#         #Left motor
#         GPIO.setup(self.p_left_fw, GPIO.OUT)
#         GPIO.setup(self.p_left_bw, GPIO.OUT)
#         GPIO.setup(self.p_left_pwm, GPIO.OUT)
        
        #Right motor
        self.pi.set_mode( self.p_right_fw, pigpio.OUTPUT)
        self.pi.set_mode( self.p_right_bw, pigpio.OUTPUT)
        self.pi.set_mode( self.p_right_pwm, pigpio.OUTPUT)
        #Left motor
        self.pi.set_mode( self.p_left_fw, pigpio.OUTPUT)
        self.pi.set_mode( self.p_left_bw, pigpio.OUTPUT)
        self.pi.set_mode( self.p_left_pwm, pigpio.OUTPUT)
        
        #PWM objects
#         self.m_left = GPIO.PWM(self.p_left_pwm, config.drive.freq)
#         self.m_right = GPIO.PWM(self.p_right_pwm, config.drive.freq)
#         
        self.pi.set_PWM_frequency(self.p_left_pwm,config.drive.freq)
        self.pi.set_PWM_frequency(self.p_right_pwm,config.drive.freq)
        
        #Movement status
        #The moving direction of the wheels
        self.sgn_left=0
        self.sgn_right=0
        #Status
        self.status=False
        self.duty=0
        self.balance=0
    #Motor functions
    
    def set_duty(self,pin,percent):
        self.pi.set_PWM_dutycycle(pin, percent*255/100.) # PWM full on
        
    def move_fw(self,duty,balance=0):
        if self.status!="move_fw":
            #self.reset_gpio()
            self.pi.write(self.p_left_fw,1)
            self.pi.write(self.p_right_fw,1)
            #Set signs
            self.sgn_left=1
            self.sgn_right=1
            #Make move
            if duty+balance<=config.drive.balance_duty_max:
                self.set_duty(self.p_left_pwm,duty+balance)
            else:
                self.set_duty(self.p_left_pwm,100)
                #self.m_left.start(100)
            if duty-balance>=0:
                self.set_duty(self.p_right_pwm,duty-balance)
            else:
                self.set_duty(self.p_right_pwm,0)
            self.status="move_fw"
            self.duty=duty
            self.balance=balance
        else:
            pass
            if duty!=self.duty or balance!=self.balance:
                if (duty+balance<=config.drive.balance_duty_max) and (duty+balance>=config.drive.balance_duty_min):
                    self.set_duty(self.p_left_pwm,duty+balance)
                elif duty+balance<config.drive.balance_duty_min:
                    self.set_duty(self.p_left_pwm,config.drive.balance_duty_min)
                elif duty+balance>config.drive.balance_duty_max:
                    self.set_duty(self.p_left_pwm,config.drive.balance_duty_max)
                else:
                    print "Error"
                    sys.exit()
                    
                if (duty-balance<=config.drive.balance_duty_max) and (duty-balance>=config.drive.balance_duty_min):
                    self.set_duty(p_right_pwm,duty-balance)
                elif duty-balance<config.drive.balance_duty_min:
                    self.set_duty(p_right_pwm,config.drive.balance_duty_min)
                elif duty-balance>config.drive.balance_duty_max:
                    self.set_duty(p_right_pwm,config.drive.balance_duty_max)
                else:
                    print "Error"
                    sys.exit()
                    
                self.duty=duty
                self.balance=balance
            
            
        return [self.sgn_left,self.sgn_right]    
            
    def move_bw(self,duty,balance=0):
        if self.status!="move_bw":
            self.reset_gpio()
            GPIO.output(self.p_left_bw, GPIO.HIGH)
            GPIO.output(self.p_right_bw, GPIO.HIGH)
            #Set signs
            self.sgn_left=-1
            self.sgn_right=-1
            
            if duty+balance<=config.drive.balance_duty_max:
                self.m_left.start(duty+balance)
            else:
                self.m_left.start(100)
            if duty-balance>=0:
                self.m_right.start(duty-balance)
            else:
                self.m_right.start(0)
            self.status="move_bw"
            self.duty=duty
            self.balance=balance
        else:
            pass
            if duty!=self.duty or balance!=self.balance:
                if duty+balance<=config.drive.balance_duty_max:
                    self.m_left.start(duty+balance)
                else:
                    self.m_left.start(100)
                if duty-balance>=0:
                    self.m_right.start(duty-balance)
                else:
                    self.m_right.start(0)
                self.duty=duty
                self.balance=balance
                
                
                
        return [self.sgn_left,self.sgn_right]
    
    
    
    def turn_right(self,duty):
        if self.status!="turn_right":
            self.reset_gpio()
            GPIO.output(self.p_left_fw, GPIO.HIGH)
            GPIO.output(self.p_right_bw, GPIO.HIGH)
            self.m_left.start(duty)
            self.m_right.start(duty)
            self.status="turn_right"
            self.duty_left=duty
            self.duty_right=duty
            #Set signs
            self.sgn_left=1
            self.sgn_right=-1
        else:

            if duty!=self.duty_left or duty!=self.duty_right:
                self.m_left.start(duty)
                self.m_right.start(duty)
        return [self.sgn_left,self.sgn_right]
    
    
    def turn_left(self,duty):
        if self.status!="turn_left":
            self.reset_gpio()
            GPIO.output(self.p_left_bw, GPIO.HIGH)
            GPIO.output(self.p_right_fw, GPIO.HIGH)
            self.m_left.start(duty)
            self.m_right.start(duty)
            self.status="turn_left"
            self.duty_left=duty
            self.duty_right=duty
            #Set signs
            self.sgn_left=-1
            self.sgn_right=1
        else:
            if duty!=self.duty_left or duty!=self.duty_right:
                self.m_left.start(duty)
                self.m_right.start(duty)

        return [self.sgn_left,self.sgn_right]
        
        
    
    def reset_gpio(self):
        GPIO.output(self.p_left_fw, GPIO.LOW)
        GPIO.output(self.p_right_fw, GPIO.LOW)
        GPIO.output(self.p_right_bw, GPIO.LOW)
        GPIO.output(self.p_left_bw, GPIO.LOW)
        #Set signs
        self.sgn_left=0
        self.sgn_right=0
        return [self.sgn_left,self.sgn_right]
    
    def break_move(self):
        self.m_left.stop()
        self.m_right.stop()
        self.reset_gpio()
        self.status=False
        #Set signs
        self.sgn_left=0
        self.sgn_right=0
        return [self.sgn_left,self.sgn_right]
    
    
    
    
    
    