#!/usr/bin/python
import smbus
import time
import math


def read_byte_c(adr):
    bus = smbus.SMBus(1)
    address = 0x1e
    return bus.read_byte_data(address, adr)

def read_word_c(adr):
    bus = smbus.SMBus(1)
    address = 0x1e
    high = bus.read_byte_data(address, adr)
    low = bus.read_byte_data(address, adr+1)
    val = (high << 8) + low
    return val

def read_word_2c_c(adr):
    val = read_word_c(adr)
    if (val >= 0x8000):
        return -((65535 - val) + 1)
    else:
        return val

def write_byte_c(adr, value):
    bus = smbus.SMBus(1)
    address = 0x1e
    bus.write_byte_data(address, adr, value)


def get_angle():

    write_byte_c(0, 0b00000000) 
    write_byte_c(1, 0b1111111) 
    write_byte_c(2, 0b00000000)
    scale = 0.92
    x_out = read_word_2c_c(3) * scale
    y_out = read_word_2c_c(7) * scale
    #z_out = read_word_2c_c(5) * scale
    
    bearing  = math.atan2(y_out, x_out) 
    if (bearing < 0):
        bearing += 2 * math.pi
    
    print "Bearing: ", math.degrees(bearing)
    
    
while 1:
    get_angle()
    