#!/usr/bin/python
#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
#|R|a|s|p|b|e|r|r|y|P|i|-|S|p|y|.|c|o|.|u|k|
#+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+-+
#
# ultrasonic_1.py
# Measure distance using an ultrasonic module
#
# Author : Matt Hawkins
# Date   : 09/01/2013

# Import required Python libraries
import time
import RPi.GPIO as GPIO

# Use BCM GPIO references
# instead of physical pin numbers
#GPIO.cleanup()
GPIO.setmode(GPIO.BOARD)


# Define GPIO to use on Pi
GPIO_TRIGGER = 22
GPIO_ECHO = 29

GPIO_TRIGGER = 32
GPIO_ECHO = 31
# 
# GPIO_TRIGGER = 36
# GPIO_ECHO = 33

# GPIO_TRIGGER = 38
# GPIO_ECHO = 35

#print "Ultrasonic Measurement"

# Set pins as output and input
GPIO.setup(GPIO_TRIGGER,GPIO.OUT)  # Trigger
GPIO.setup(GPIO_ECHO,GPIO.IN)      # Echo

while True:
    # Set trigger to False (Low)
    GPIO.output(GPIO_TRIGGER, False)
    
    # Allow module to settle
    time.sleep(0.05)
    
    # Send 10us pulse to trigger
    #print "Sending Signal"
    GPIO.output(GPIO_TRIGGER, True)
    time.sleep(0.00001)
    GPIO.output(GPIO_TRIGGER, False)
    
    start = time.time()
    #print "Triggering"
    while GPIO.input(GPIO_ECHO)==0:
        #print GPIO.input(GPIO_ECHO)
        start = time.time()
    
    #print "Expecting Input"
    while GPIO.input(GPIO_ECHO)==1:
        stop = time.time()
    
    # Calculate pulse length
    elapsed = stop-start
    
    # Distance pulse travelled in that time is time
    # multiplied by the speed of sound (cm/s)
    distance = elapsed * 34320
    
    # That was the distance there and back so halve the value
    distance = distance / 2
    
    #Static correlation
    distance=distance-0
    print "Distance : %.1f cm" % distance

# Reset GPIO settings
GPIO.cleanup()