#!/usr/bin/python
import pygame
import RPi.GPIO as GPIO
import time
import smbus
import time
import math
from time import sleep

#Compass functions
def read_byte_compass(adr):
    return bus.read_byte_data(address, adr)

def read_word_compass(adr):
    high = bus.read_byte_data(address, adr)
    low = bus.read_byte_data(address, adr+1)
    val = (high << 8) + low
    return val

def read_word_2c_compass(adr):
    val = read_word(adr)
    if (val >= 0x8000):
        return -((65535 - val) + 1)
    else:
        return val

def write_byte_compass(adr, value):
    bus.write_byte_data(address, adr, value)

def get_earth_angle():
    write_byte(0, 0b00000000) 
    write_byte(1, 0b1111111) 
    write_byte(2, 0b00000000)  

    scale = 0.92

    x_out = read_word_2c(3) * scale
    y_out = read_word_2c(7) * scale
    #z_out = read_word_2c(5) * scale
    
    bearing  = math.atan2(y_out, x_out) 
    if (bearing < 0):
        bearing += 2 * math.pi
    
    return math.degrees(bearing)




#Motor functions
def move_fw_start():
    global straight_duty
    
    GPIO.output(motor_left_fw, GPIO.HIGH)
    GPIO.output(motor_right_fw, GPIO.HIGH)
    
    print "GPIO is high"

    p_left.start(straight_duty)
    p_right.start(straight_duty)

def move_fw_end():
    
    p_left.stop()
    p_right.stop()
    GPIO.output(motor_left_fw, GPIO.LOW)
    GPIO.output(motor_right_fw, GPIO.LOW)
    
def move_bw_start():
    global straight_duty
    
    GPIO.output(motor_left_bw, GPIO.HIGH)
    GPIO.output(motor_right_bw, GPIO.HIGH)
    
    print "GPIO is high"

    p_left.start(straight_duty)
    p_right.start(straight_duty)
    
    
def move_bw_end():
    
    p_left.stop()
    p_right.stop()
    
    GPIO.output(motor_left_bw, GPIO.LOW)
    GPIO.output(motor_right_bw, GPIO.LOW)

    
    
    
def turn_right_start():
    global straight_duty,status
    
    if status!="turn_right":
        GPIO.output(motor_left_fw, GPIO.HIGH)
        GPIO.output(motor_right_bw, GPIO.HIGH)
        
        print "GPIO is high"
    
        p_left.start(straight_duty)
        p_right.start(straight_duty)
        status="turn_right"
    
def turn_right_end():
    
    global straight_duty,status
    
    if status=="turn_right":
        p_left.stop()
        p_right.stop()
        GPIO.output(motor_left_fw, GPIO.LOW)
        GPIO.output(motor_right_bw, GPIO.LOW)
        status=False
    
def turn_left_start():
    global straight_duty
    
    GPIO.output(motor_left_bw, GPIO.HIGH)
    GPIO.output(motor_right_fw, GPIO.HIGH)
    
    print "GPIO is high"

    p_left.start(straight_duty)
    p_right.start(straight_duty)
    
def turn_left_end():
    p_left.stop()
    p_right.stop()
    GPIO.output(motor_left_bw, GPIO.LOW)
    GPIO.output(motor_right_fw, GPIO.LOW)


def terminate():
    print "Terminating.."
    GPIO.cleanup()
    sys.exit()
    
    
#########################################
#Motor Initializing
#Board layout
GPIO.setmode(GPIO.BOARD)

#Right motor pins
motor_right_bw=12
motor_right_fw=11
motor_right_pwm=16

#Left motor pins
motor_left_bw=15
motor_left_fw=13
motor_left_pwm=18

#Define the pins
#Right motor
GPIO.setup(motor_right_fw, GPIO.OUT)
GPIO.setup(motor_right_bw, GPIO.OUT)
GPIO.setup(motor_right_pwm, GPIO.OUT)
#Left motor
GPIO.setup(motor_left_fw, GPIO.OUT)
GPIO.setup(motor_left_bw, GPIO.OUT)
GPIO.setup(motor_left_pwm, GPIO.OUT)

#Both motors are off
GPIO.output(motor_right_fw, GPIO.LOW)
GPIO.output(motor_right_bw, GPIO.LOW)
GPIO.output(motor_left_fw, GPIO.LOW)
GPIO.output(motor_left_bw, GPIO.LOW)

p_left = GPIO.PWM(motor_left_pwm, 50)
p_right = GPIO.PWM(motor_right_pwm, 50)


straight_duty=70
turn_duty=50

#Compass initializing
bus = smbus.SMBus(1)
address = 0x1e


    
# Script
#Move status
status=False
target_angle=90
epsilon=5


angle=get_earth_angle()
time.sleep(0.1)
while True:
    
    time.sleep(1/10)
    angle=get_earth_angle()
    print angle
    if not (angle<target_angle+epsilon and angle>target_angle-epsilon):
        turn_right_start()
        #time.sleep(0.1)
        #pass
        
    else:
        turn_right_end()
        break
        #pass
        


