#!/usr/bin/python
#############################################################
#############################################################
# Auto Drive
# Author: Can Kosar
#############################################################

#Standard libraries
import sys
import os
import time
import math
import numpy as np
import pygame
import sys

#Custom libraries
sys.path.append("../lib/")
import l_drive
import l_odo
import l_config
import l_monitoring
import l_misc
#Animation
# m=l_monitoring.monitor_asynch()
# m.start()
# 
# 
# 
# time.sleep(5)
# 
# sys.exit()

# pygame.init()
# screen = pygame.display.set_mode((640, 480))
# 
# time.sleep(2)
# 
# pygame.display.quit()
# pygame.quit()
# sys.exit()

#Initializing
config=l_config.config


def get_local_movement(d_a_l,d_a_r):
    if d_a_l!=d_a_r:
        r=(d*(d_a_l+d_a_r))/(2.*(d_a_l-d_a_r))
        
        d_alpha_hat=(d_a_l-d_a_r)/d
        dx_hat=r*math.sin(d_alpha_hat)
        dy_hat=r*(1-math.cos(d_alpha_hat))
    else:
        r=float("inf")
        dx_hat=d_a_l
        dy_hat=0
        d_alpha_hat=0
    
    if True:
        print "################################   Turn ",i,"   ######################################"
        #print "Actual enc_l= ",enc_l[-1]," Actual enc_r= ",enc_r[-1]
        print "Diff enc_l= ",d_a_l," Diff enc_r= ",d_a_r
        print "Actual radius= ",r
        print "Diff arc angle= ",d_alpha_hat,"(",math.degrees(d_alpha_hat),")", "Diff x local= ",dx_hat," Diff y local= ",dy_hat
        print "-------------Kinematics equations-------------"
    
    #Local coordinate system
    return np.matrix([dx_hat,dy_hat,d_alpha_hat]).transpose()


#Odometry
odo=l_odo.odo_asynch() #Define object
odo.start(False) #Start measuring with the frequency
#Drive       
drive=l_drive.drive()
sgn=drive.move_fw(70,0)
#sgn=drive.turn_left(100)
odo.set_sign(sgn)



 
#Controlling
d=config.hardware.wheel_distance
a_l_last=0
a_r_last=0

u_global=np.matrix([0,0,0]).transpose()
enc_l=[0]
enc_r=[0]


print "######################Main loop###################################"
print "#                                                                #"
print "#                                                                #"
print "#                                                                #"
print "#                                                                #"
print "##################################################################"
i=1
while True:
    #print "t=%.6f\tleft=%.6f(%d)\tright=%.6f(%d)"%(odo.t_label.value,odo.rad_to_arc(odo.enc_l.value),odo.enc_l.value,odo.rad_to_arc(odo.enc_r.value),odo.enc_r.value)
    ####################################
    #Position prediction
    enc_l.append(odo.rad_to_arc(odo.enc_l.value))
    enc_r.append(odo.rad_to_arc(odo.enc_r.value))
 
    du_local=get_local_movement(enc_l[-1]-enc_l[-2],enc_r[-1]-enc_r[-2])

    
    #print du_local.shape
    #Rotation of the local system regarding the global system 
    d_alpha_gl=u_global[2,-1]
    #Transformation-matrix
    T= np.matrix([[math.cos(d_alpha_gl), -math.sin(d_alpha_gl),0],
                  [math.sin(d_alpha_gl), math.cos(d_alpha_gl),0],
                  [0,0,1]])
    #print T.shape
    du_global=T*du_local
    
    u_global=np.concatenate((u_global,u_global[:,-1]+du_global),axis=1)
    #print u_global[:,-1]
    #print u_global.shape
    #print u_global[:,-1]
    #sys.exit()
    #print u_global.shape
    #sys.exit()
    #print u_global
    time.sleep(0.1)
    
    #############################################
    #Shell monitoring#

    if True:
        print "du_local"
        print l_misc.plots().print_matrix(du_local)
        print "T"
        print l_misc.plots().print_matrix(T)
        print "du_global"
        print l_misc.plots().print_matrix(du_global)
        print "u_global"
        print l_misc.plots().print_matrix(u_global)
        print "\n\n\n"
    
    
    
    i+=1
    
    x_act=u_global[0,-1]


    #if i>=10: 
    if x_act>=100:
        drive.break_move()
        odo.end()
        break


#One piece arc
du_global_op=get_local_movement(enc_l[-1],enc_r[-1])



print "Global position"
print u_global[:,-1]
print "Global position one piece arc"
print du_global_op
#print "Distance x is  ",x_act, "Distance one piece is ",du_global_op[0]
    
    # print "Left encoder: %d \tRight encoder: %d\tLeft arc: %.3f \tRight arc: %.3f" %(enc_l,enc_r,l_arc_l,l_arc_r)
# 
# # l_misc.plots().write_gnu_file("odometry.dat",[arr_t,arr_enc_l,arr_enc_r],"%.6f")
# # os.system("gnuplot -e \"plot  'odometry.dat' using 1:2 with lines, 'odometry.dat' using 1:3 with lines,'odometry.dat' using 1:4 with lines, 'odometry.dat' using 1:5 with lines;pause -1\"")
#         